name DATA_ACQUISITION_SYSTEM     
;DATA ACQUISITION SYSTEM service program
;The system is based upon the 80C51 microcontroller,
;the Analog Devices 12-bit sampling ADC AD7883 and
;the Analog Devices 16-Channel, 8-bit Multiplying DAC AD8600.
;This monitor program works with every TERMINAL-program,
;running on the host PC.

CR      equ 0Dh
LF      equ 0Ah
EOT     equ 04h
PCON    equ 87h
ADCADDR equ 8000h

        org 0003h
        LCALL SYNC              ;External interrupt 0 service
        SETB PSW.5              ;subroutine
        CLR A
        RETI

        org 000Bh               ;Timer0 overflow service sbr.
        SETB PSW.1
        RETI

        org 0023h
        MOV A,SCON              ;This is the serial interrupt
        ANL A,#03h              ;service subroutine.
        CJNE A,#01h,LINT0       ;The received bytes are stored
        MOV A,SBUF              ;in the internal RAM space,
        INC R0                  ;beginning from 031hex, which
        MOV @R0,A               ;is specified in the main
LINT0:  MOV SCON,#50h           ;subroutine
        RETI

        org 0000h
        LCALL MAIN

        org 0060h
MAIN:   MOV R0,#30h
        MOV @R0,#00h
        MOV IE,#80h
        ORL PCON,#80h           ;Setting the double baud rate bit
        MOV TMOD,#20h           ;Timer 1 as 8-bit auto reload timer
        MOV TCON,#45h           ;Falling edge triggered ext.interrupt
        MOV TH1,#0FBh           ;Specifies 9600 bps
        MOV SCON,#50h
L00:    LCALL RECEIVE           ;calls the Receive sbr.to take
        MOV R0,#31h             ;characters, send from the terminal
        CJNE @R0,#CR,L0
        INC R0
        CJNE @R0,#LF,L0
        LCALL INITM             ;calls the INITM for menu
        MOV R0,#30h
        MOV @R0,#00h
L001:   SJMP L00
L0:     MOV R0,#31h
        CJNE @R0,#'S',L1
        INC R0
        CJNE @R0,#'M',L1
        INC R0
        CJNE @R0,#CR,L1
        INC R0
        CJNE @R0,#LF,L1
        LCALL SM                ;calls the SM for single
        MOV R0,#30h             ;measurement
        MOV @R0,#00h
L01:    SJMP L001
L1:     MOV R0,#31h
        CJNE @R0,#'S',L2
        INC R0
        CJNE @R0,#'S',L2
        INC R0
        CJNE @R0,#'M',L2
        INC R0
        CJNE @R0,#CR,L2
        INC R0
        CJNE @R0,#LF,L2
        LCALL SSM               ;calls the SSM for single
        MOV R0,#30h             ;synchronized measurement
        MOV @R0,#00h
L11:    SJMP L01
L2:     MOV R0,#31h
        CJNE @R0,#'M',L3
        INC R0
        CJNE @R0,#'M',L3
        INC R0
        CJNE @R0,#CR,L3
        INC R0
        CJNE @R0,#LF,L3
        LCALL MM                ;calls the MM for multiple
        MOV R0,#30h             ;measurement
        MOV @R0,#00h
L21:    SJMP L11
L3:     MOV R0,#31h
        CJNE @R0,#'M',L4
        INC R0
        CJNE @R0,#'S',L4
        INC R0
        CJNE @R0,#'M',L4
        INC R0
        CJNE @R0,#CR,L4
        INC R0
        CJNE @R0,#LF,L4
        LCALL MSM               ;calls MSM for multiple
        MOV R0,#30h             ;synchronized measurement
        MOV @R0,#00h
L31:    SJMP L21
L4:     MOV R0,#31h
        CJNE @R0,#'M',L5
        INC R0
        CJNE @R0,#'M',L5
        INC R0
        CJNE @R0,#'+',L5
        INC R0
        INC R0
        INC R0
        INC R0
        INC R0
        CJNE @R0,#CR,L5
        INC R0
        CJNE @R0,#LF,L5
        LCALL MMN               ;calls the MMN for multiple
        MOV R0,#30h             ;measurement with time
        MOV @R0,#00h            ;magnification
L41:    SJMP L31
L5:     MOV R0,#31h
        CJNE @R0,#'M',L6
        INC R0
        CJNE @R0,#'S',L6
        INC R0
        CJNE @R0,#'M',L6
        INC R0
        CJNE @R0,#'+',L6
        INC R0
        INC R0
        INC R0
        INC R0
        INC R0
        CJNE @R0,#CR,L6
        INC R0
        CJNE @R0,#LF,L6
        LCALL MSMN              ;calls the MSMN for multiple
        MOV R0,#30h             ;synchronized measurement
        MOV @R0,#00h            ;with time magnification
L51:    SJMP L41
L6:     MOV R0,#31h
        CJNE @R0,#'D',L7
        INC R0
        CJNE @R0,#'A',L7
        INC R0
        CJNE @R0,#'C',L7
        INC R0
        INC R0
        CJNE @R0,#' ',L7
        INC R0
        INC R0
        INC R0
        CJNE @R0,#CR,L7
        INC R0
        CJNE @R0,#LF,L7
        LCALL SDAC              ;calls the SDAC for using
        MOV R0,#30h             ;a single DAC
        MOV @R0,#00h
L61:    SJMP L51
L7:     MOV R0,#31h
        CJNE @R0,#'S',L70
        SJMP L700
L70:    CJNE @R0,#'M',L8
L700:   INC R0
        CJNE @R0,#'F',L8
        INC R0
        CJNE @R0,#'G',L8
        INC R0
        INC R0
        CJNE @R0,#' ',L8
        INC R0
        INC R0
        INC R0
        INC R0
        INC R0
        CJNE @R0,#CR,L8
        INC R0
        CJNE @R0,#LF,L8
        LCALL FUNCT             ;calls the FUNCT for using
        MOV R0,#30h             ;single or multiple
        MOV @R0,#00h            ;function generators
L71:    SJMP L61
L8:     LCALL ERRMESS
        MOV R0,#30h
        MOV @R0,#00h            ;if nothing from the above
        SJMP L71                ;sends an error message and
                                ;returns to begin

        org 0600h
RECEIVE:MOV IE,#90h             ;Receive subroutine, which works
REC1:   CJNE @R0,#CR,RECL0      ;in cooperation with the
        SJMP RECL1              ;serial interrupt service sbr.
RECL0:  SJMP REC1               ;This subroutine is not
RECL1:  CJNE @R0,#LF,RECL2      ;terminated until a CR LF is
        SJMP RECL3              ;received
RECL2:  SJMP RECL1
RECL3:  MOV IE,#80h
        RET

        org 0620h
INITM:  MOV DPTR,#IMLKUP        ;Subroutine for sending the initial
        CLR A                   ;message with options
INITL1: MOVC A,@A+DPTR
        CJNE A,#EOT,INITL0
        RET
INITL0: LCALL SEND
        CLR A
        INC DPTR
        SJMP INITL1

        org 0650h
SEND:   MOV SBUF,A              ;Subroutine for sending a byte, loaded in
SENDL0: JNB SCON.1,SENDL0       ;accumulator A
        CLR SCON.1
        RET

        org 0670h
ASCII:  MOV R2,A                ;This subroutine converts
        CLR C                   ;the HEX-number in A in
        SUBB A,#0Ah             ;ASCII-format
        JNC ASCL0
        CLR C
        MOV A,R2
        ADD A,#30h
        RET
ASCL0:  MOV A,R2
        ADD A,#37h
        RET

        org 0690h
ASCIIB: MOV R2,A                ;This program converts
        CLR C                   ;the ASCII-charecter in A
        SUBB A,#3Ah             ;in HEX-format
        JNC ABL0
        MOV A,R2                ;is the ASCII char.a number
        CLR C
        SUBB A,#30h
        JC ABL1
        RET
ABL0:   MOV A,R2
        CLR C
        SUBB A,#47h
        JNC ABL1
        MOV A,R2                ;is the ASCII char.a letter
        CLR C                   ;from A to F
        SUBB A,#41h
        JC ABL1
        MOV A,R2
        CLR C
        SUBB A,#37h
        RET
ABL1:   MOV A,#0FFh             ;if the ASCII format is not
        RET                     ;correct, returns FFhex


        org 06C0h
ADC:    MOV DPTR,#ADCADDR       ;ADC-meas.subroutine
        MOVX @DPTR,A            ;The address of the ADC
        CLR C                   ;is ADCADDR. Writing to this
LADC1:  MOV C,P3.4              ;address starts the conversion.
        JC LADC0
        SJMP LADC1              ;Signal BUZY is connected to P3.4
LADC0:  MOV DPTR,#ADCADDR
        MOVX A,@DPTR
        MOV R1,P1
        RET

        org 06E0h
SM:     LCALL ADC               ;Single measurement
        MOV B,A                 ;subroutine
        MOV A,R1
        ANL A,#0Fh              ;The high order byte
        LCALL ASCII             ;of the ADC-result is in R1
        LCALL SEND
        MOV A,B
        ANL A,#0F0h             ;The result is packed
        SWAP A                  ;in HEX-format and then
        LCALL ASCII             ;send to the terminal
        LCALL SEND
        MOV A,B
        ANL A,#0Fh
        LCALL ASCII
        LCALL SEND
        MOV A,#CR
        LCALL SEND
        MOV A,#LF
        LCALL SEND
        RET

        org 0720h
ERRMESS:MOV DPTR,#EMLKUP        ;sends an error-message
MESS:   CLR A                   ;sends a general prps.message
        MOV B,#00h
ERRL1:  MOVC A,@A+DPTR
        CJNE A,#EOT,ERRL0       ;sends characters until EOT
        RET                     ;is reached
ERRL0:  LCALL SEND
        INC B
        MOV A,B
        SJMP ERRL1


        org 0740h
SYNC:   CJNE A,#01h,SYNCL0      ;means, that the program is
        LCALL SM                ;called from SSM
        RET
SYNCL0: CJNE A,#02h,SYNCL1      ;means, that the program is
        LCALL MM                ;called from MSM
        RET
SYNCL1: CJNE A,#03h,SYNCL2      ;means, that the program is
        MOV R0,#35h             ;called from MSM+NNNN
        LCALL MMN1
        RET
SYNCL2: LCALL ERRMESS
        RET


        org 0770h
SSM:    CLR PSW.5               ;Subroutine for single synchronized
        MOV A,#01h              ;measurement. If a "T" key is pressed
        MOV R0,#30h             ;the program is terminated. The
        MOV IE,#91h             ;interrupt enable register is initialized
SSML0:  JB PSW.5,SSML1          ;to allow servicing the external
        MOV R0,#30h             ;interrupt 0. When an external interrupt
        CJNE A,#'T',SSML2       ;is generated and serviced the user
        MOV IE,#80h             ;defined flag PSW.5 is set
        LCALL TMESS
        MOV SCON,#50h
        RET                     ;The value #01hex in A tells the SYNC
SSML2:  SJMP SSML0              ;subroutine, that it is called from
SSML1:  MOV IE,#80h             ;the SSM subroutine
        RET

        org 0795h
TMESS:  MOV DPTR,#TMLKUP        ;sends a terminate message
        LCALL MESS
        RET

        org 07A0h
ADCM:   MOV TH0,DPH             ;AD-measurement sbr.,which works
        MOV TL0,DPL             ;toghether with the MM+NNNN sbr.
        MOV DPTR,#ADCADDR
        MOVX @DPTR,A            ;starting the ADC
        CLR C
ADCML1: MOV C,P3.4              ;waiting for ADC completing the
        JC ADCML0               ;work
        SJMP ADCML1
ADCML0: MOVX A,@DPTR            ;storing the value
        MOV R1,A                ;Low Byte - R1
        MOV A,P1                ;High Byte - A
        MOV DPH,TH0
        MOV DPL,TL0             ;restoring the RAM-address
        RET

        org 07D0h
MM:     MOV DPTR,#0000h         ;Multiple measurement sbr.
ML0:    LCALL ADCM              ;makes a measurement
        MOVX @DPTR,A
        INC DPTR                ;stores the measurement in RAM
        MOV A,R1
        MOVX @DPTR,A
        INC DPTR
        MOV A,DPH               ;checks if the RAM is full
        CLR C
        SUBB A,#80h
        JC ML0
        MOV DPTR,#0000h
        LCALL MMLAB2            ;sends the measurement to the
        RET                     ;terminal computer


        org 0800h
MSM:    CLR PSW.5               ;Multiple Sync.Meas.sbr.
        MOV A,#02h              ;tells the SYNC-sbr.,that
        MOV R0,#30h             ;it is called from MSM
        MOV IE,#91h
MSML0:  JB PSW.5,MSML1          ;terminates if the interrupt
        MOV R0,#30h             ;is serviced
        CJNE A,#'T',MSML2       ;terminates if a "T" is pressed
        MOV IE,#80h
        LCALL TMESS
        MOV SCON,#50h
        RET
MSML2:  SJMP MSML0
MSML1:  MOV IE,#80h
        RET


        org 0830h
MMN:    MOV R0,#34h             ;Subroutine for making
MMN1:   MOV A,@R0               ;multiple measurement with
        LCALL ASCIIB            ;time magnification
        CJNE A,#0FFh,MMLAB3
        LJMP MMLAB7
MMLAB3: SWAP A
        MOV B,A
        INC R0
        MOV A,@R0
        LCALL ASCIIB
        CJNE A,#0FFh,MMLAB4
        LJMP MMLAB7
MMLAB4: ORL A,B
        CPL A
        MOV R4,A
        INC R0
        MOV A,@R0
        LCALL ASCIIB
        CJNE A,#0FFh,MMLAB5
        LJMP MMLAB7
MMLAB5: SWAP A
        MOV B,A
        INC R0
        MOV A,@R0
        LCALL ASCIIB
        CJNE A,#0FFh,MMLAB6
        LJMP MMLAB7
MMLAB6: ORL A,B
        CPL A
        MOV R3,A                ;The format of NNNN is
        CLR PSW.1               ;prepared
        MOV SCON,#50h
        MOV IE,#82h             ;Timer0 initialization
        MOV TMOD,#21h
        MOV DPTR,#0000h
MMLAB1: LCALL ADCM              ;calls the measurement sbr.
        MOV TH0,R4
        MOV TL0,R3
        MOV TCON,#55h
MMLAB0: JNB PSW.1,MMLAB0        ;waiting until T0 overflows
        MOV TCON,#45h
        CLR PSW.1
        MOVX @DPTR,A            ;storing the data in ext.RAM
        INC DPTR                ;the high order byte first
        MOV A,R1
        MOVX @DPTR,A
        INC DPTR
        JNB SCON.0,MMLAB8       ;checks if a program terminate
        MOV A,SBUF              ;request is made
        CJNE A,#'T',MMLAB9
        LCALL TMESS
        SJMP MMLAB10
MMLAB9: CLR SCON.0
MMLAB8: MOV A,DPH               ;checks if the external RAM is
        CLR C                   ;full (16k measurements)
        SUBB A,#80h
        JC MMLAB1
MMLAB10:MOV IE,#80h             ;if full sends the contents
        MOV DPTR,#0000h         ;to the terminal computer
MMLAB2: MOVX A,@DPTR
        ANL A,#0Fh              ;prepares the correct
        LCALL ASCII             ;ASCII-format
        LCALL SEND
        INC DPTR
        MOVX A,@DPTR
        ANL A,#0F0h
        SWAP A
        LCALL ASCII
        LCALL SEND
        MOVX A,@DPTR
        ANL A,#0Fh
        LCALL ASCII
        LCALL SEND
        MOV A,#CR               ;with the end of every value
        LCALL SEND              ;sends a CR LF
        MOV A,#LF
        LCALL SEND
        INC DPTR
        MOV A,DPH               ;checks if all RAM is send
        CLR C
        SUBB A,#80h
        JC MMLAB2
        CLR SCON.0
        RET
MMLAB7: LCALL ERRMESS           ;sends an error message if the
        RET                     ;ASCII-format is not correct

        org 0900h
MSMN:   CLR PSW.5               ;MSM+NNNN subroutine
        MOV A,#03h              ;tells the SYNC-sbr, that it
        MOV R0,#30h             ;is called from MSM+NNNN
        SETB IP.1
        MOV IE,#91h
MSMNL0: JB PSW.5,MSMNL1         ;waits that the external
        MOV R0,#30h             ;interrupt is called
        CJNE A,#'T',MSMNL2      ;checks if a "T" is pressed
        MOV IE,#80h
        LCALL TMESS
        MOV SCON,#50h
        CLR IP.1
        RET
MSMNL2: SJMP MSMNL0
MSMNL1: MOV IE,#80h
        CLR IP.1
        RET

        org 0940h
SDAC:   MOV R0,#34h             ;loading a single DAC
        MOV A,@R0
        LCALL ASCIIB
        CJNE A,#0FFh,DACL0
        LCALL ERRMESS
        RET
DACL0:  MOV R3,A                ;storing the number ot the DAC
        MOV R0,#36h
        MOV A,@R0
        LCALL ASCIIB
        CJNE A,#0FFh,DACL1      ;preparing the HEX-format
        LCALL ERRMESS
        RET
DACL1:  SWAP A
        MOV B,A
        INC R0
        MOV A,@R0
        LCALL ASCIIB
        CJNE A,#0FFh,DACL2      ;preparing the HEX-format
        LCALL ERRMESS
        RET
DACL2:  ORL A,B
        MOV B,A                 ;storing the DAC-value
        MOV DPL,#00h
        MOV A,#0E0h             ;calculating the DAC-address
        ADD A,R3
        ADD A,R3
        MOV DPH,A
        MOV A,B
        MOVX @DPTR,A            ;loading the DAC-register
        MOV DPTR,#0C000h
        MOVX A,@DPTR            ;updating the DAC-buffers
        RET

        org 09A0h
FUNCT:  MOV R0,#34h             ;Single and multiple function
        MOV A,@R0               ;generators subroutine
        LCALL ASCIIB
        CJNE A,#0FFh,SFL0
        LCALL ERRMESS
        RET
SFL0:   MOV R3,A                ;stores the number of selected DAC
        MOV R0,#36h
        MOV A,@R0
        LCALL ASCIIB            ;preparing HEX-format
        CJNE A,#0FFh,SFL1
        LCALL ERRMESS
        RET
SFL1:   SWAP A
        MOV B,A
        INC R0
        MOV A,@R0
        LCALL ASCIIB            ;preparing HEX-format
        CJNE A,#0FFh,SFL2
        LCALL ERRMESS
        RET
SFL2:   ORL A,B
        CPL A
        MOV R4,A                ;stores the time division
        INC R0                  ;high byte
        MOV A,@R0
        LCALL ASCIIB            ;preparing HEX-format
        CJNE A,#0FFh,SFL3
        LCALL ERRMESS
        RET
SFL3:   SWAP A
        MOV B,A
        INC R0
        MOV A,@R0
        LCALL ASCIIB            ;preparing HEX-format
        CJNE A,#0FFh,SFL4
        LCALL ERRMESS
        RET
SFL4:   ORL A,B
        CPL A
        MOV R5,A                ;stores the time division
        MOV R0,#31h             ;low byte
        MOV A,@R0
        CJNE A,#'S',MFL0        ;is it a single or multiple f.g.
        SJMP SFL5
MFL0:   LJMP MFL1               ;Sbr.for multiple func.generators
SFL5:   MOV DPTR,#SFLKUP
        LCALL MESS              ;Sends the "send-file" message
        MOV DPTR,#0000h
        MOV SCON,#50h
SFL6:   JNB SCON.0,SFL6
        MOV A,SBUF
        CJNE A,#1Ah,SL0         ;looks for the end of the file
        SJMP SFL12
SL0:    LCALL ASCIIB
        CJNE A,#0FFh,SFL7
        LCALL ERRMESS
        RET
SFL7:   SWAP A                  ;preparing the HEX-format for
        MOV B,A                 ;the value
        MOV SCON,#50h
SFL8:   JNB SCON.0,SFL8
        MOV A,SBUF
        LCALL ASCIIB
        CJNE A,#0FFh,SFL9
        LCALL ERRMESS
        RET
SFL9:   ORL A,B                 ;preparing the HEX-format
        MOVX @DPTR,A            ;storing the data in RAM
        INC DPTR
        MOV SCON,#50h
SFL10:  JNB SCON.0,SFL10        ;every line in the file
        MOV SCON,#50h           ;must end with CR LF
SFL11:  JNB SCON.0,SFL11
        MOV SCON,#50h
        SJMP SFL6
SFL12:  MOV R1,DPH              ;stores the end address of the
        MOV R2,DPL              ;DAC-values table in RAM
        MOV A,#'O'
        LCALL SEND              ;sends "OK", if the file is
        MOV A,#'K'              ;received
        LCALL SEND
        MOV A,#CR
        LCALL SEND
        MOV A,#LF
        LCALL SEND
        MOV SCON,#50h
        MOV R6,#00h
        MOV A,#0E0h
        ADD A,R3
        ADD A,R3                ;calculating the DAC-address
        MOV R7,A
        CLR PSW.1
        MOV IE,#82h             ;preparing timer0 as overflow
        MOV TMOD,#21h           ;timer
        MOV DPTR,#0000h
SFL16:  MOVX A,@DPTR            ;storing the value in the
        MOV TL0,DPL             ;DAC-register
        MOV TH0,DPH
        MOV DPL,R6
        MOV DPH,R7
        MOVX @DPTR,A
        MOV DPTR,#0C000h
        MOVX A,@DPTR            ;updating the output buffers
        MOV DPL,TL0
        MOV DPH,TH0             ;restoring the RAM-address
        INC DPTR
        MOV TH0,R4
        MOV TL0,R5
        MOV TCON,#55h
SFL13:  JNB PSW.1,SFL13         ;generating time delay NNNN
        MOV TCON,#45h
        CLR PSW.1
        JNB SCON.0,SFL14
        MOV A,SBUF
        CJNE A,#'T',SFL15       ;checking for a pressed "T"
        CLR SCON.0
        MOV DPL,R6
        MOV DPH,R7
        CLR A
        MOVX @DPTR,A            ;if so clearing the DAC
        MOV DPTR,#0C000h
        MOVX A,@DPTR
        LCALL TMESS
        RET
SFL15:  CLR SCON.0
SFL14:  MOV A,R2
        CJNE A,DPL,SFL17        ;checks,if the end of the
        MOV A,R1                ;RAM-table is reached
        CJNE A,DPH,SFL17
        MOV DPTR,#0000h         ;if so begins from the
SFL17:  SJMP SFL16              ;initial address in RAM


        org 0AC2h
;Subroutine for the creating of multiple function generators.
;This subroutine is called from the main program with the
;command MFGN MMMM, where N can be any valid number from 0hex
;till Fhex and means that all DAC-s, beginning from the DAC0
;and ending with DACN, are configured as valid function generators.
;MMMM is the the number of additional cycles, which are added
;to the normal flow of the program, to zoom the t-axis of all
;function generators, making possible the generation of different
;arbittrary repetition frequencies.

MFL1:   MOV DPTR,#0000h
        INC R3
        MOV R1,#40h
        MOV R0,#00h
MFL2:   MOV TH0,DPH
	MOV TL0,DPL
        MOV DPTR,#MFLKUP
        LCALL MESS              ;Message for sending the
        MOV A,R0                ;appropriate file for
        LCALL ASCII             ;the corresponding function generator
        LCALL SEND
        MOV A,#CR
        LCALL SEND
        MOV A,#LF
        LCALL SEND
	MOV DPH,TH0
	MOV DPL,TL0
        MOV SCON,#50h
MFL3:   JNB SCON.0,MFL3         ;Storing the data from the file for
        MOV A,SBUF              ;the N function generator in the
        CJNE A,#1Ah,MF0         ;RAM-memory
        SJMP MFL9
MF0:    LCALL ASCIIB
        CJNE A,#0FFh,MFL4
        LCALL ERRMESS
        RET
MFL4:   SWAP A
        MOV B,A
        MOV SCON,#50h
MFL5:   JNB SCON.0,MFL5
        MOV A,SBUF
        LCALL ASCIIB
        CJNE A,#0FFh,MFL6
        LCALL ERRMESS
        RET
MFL6:   ORL A,B
        MOVX @DPTR,A
        INC DPTR
        MOV SCON,#50h
MFL7:   JNB SCON.0,MFL7
        MOV SCON,#50h
MFL8:   JNB SCON.0,MFL8
        MOV SCON,#50h
        SJMP MFL3
MFL9:   MOV A,#CR
        LCALL SEND
        MOV A,#LF
        LCALL SEND
        MOV @R1,DPL             ;Storing the end address of the
        INC R1                  ;data table in RAM for the
        MOV @R1,DPH             ;N-th function generator
        INC R1
        INC R0
        MOV A,R0
        MOV B,R3
        CJNE A,B,MFL2
        MOV A,#'O'              ;Sends 'OK' message after all data
        LCALL SEND              ;necessary for function is send
        MOV A,#'K'
        LCALL SEND
        MOV A,#CR
        LCALL SEND
        MOV A,#LF
        LCALL SEND
        MOV R0,#60h             ;Transfers the table with
        MOV R1,#40h             ;the end adresses of the DAC-s
        MOV @R0,#00h            ;value tables, which is allocated
        INC R0                  ;in internal RAM, beginning from
        MOV @R0,#00h            ;40hex, into a table with
        INC R0                  ;the current addresses of reading
MFL12:  MOV A,R3                ;for the DAC-s, which is allocated
        ADD A,R3                ;in internal RAM, beginning from
        ADD A,#60h              ;60hex
        MOV B,R0
        CJNE A,B,MFL10
        SJMP MFL11
MFL10:  MOV A,@R1
        MOV @R0,A
        INC R0
        INC R1
        MOV A,@R1
        MOV @R0,A
        INC R0
        INC R1
        SJMP MFL12
MFL11:  CLR PSW.1               ;Prepares the timer0 as overflow
        MOV IE,#82h             ;interrupt timer
        MOV TMOD,#21h
        MOV SCON,#50h
MFL13:  MOV R0,#60h
        MOV R1,#40h
        MOV B,#00h
        MOV R6,#0E0h
        LCALL FUNCG             ;function generator 0
        INC B
        MOV A,R3
        CJNE A,B,MFL14
        LJMP MFL100
MFL14:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 1
        INC B
        MOV A,R3
        CJNE A,B,MFL15
        LJMP MFL100
MFL15:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 2
        INC B
        MOV A,R3
        CJNE A,B,MFL16
        LJMP MFL100
MFL16:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 3
        INC B
        MOV A,R3
        CJNE A,B,MFL17
        LJMP MFL100
MFL17:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 4
        INC B
        MOV A,R3
        CJNE A,B,MFL18
        LJMP MFL100
MFL18:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 5
        INC B
        MOV A,R3
        CJNE A,B,MFL19
        LJMP MFL100
MFL19:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 6
        INC B
        MOV A,R3
        CJNE A,B,MFL20
        LJMP MFL100
MFL20:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 7
        INC B
        MOV A,R3
        CJNE A,B,MFL21
        LJMP MFL100
MFL21:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 8
        INC B
        MOV A,R3
        CJNE A,B,MFL22
        LJMP MFL100
MFL22:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator 9
        INC B
        MOV A,R3
        CJNE A,B,MFL23
        LJMP MFL100
MFL23:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator A
        INC B
        MOV A,R3
        CJNE A,B,MFL24
        LJMP MFL100
MFL24:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator B
        INC B
        MOV A,R3
        CJNE A,B,MFL25
        LJMP MFL100
MFL25:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator C
        INC B
        MOV A,R3
        CJNE A,B,MFL26
        LJMP MFL100
MFL26:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator D
        INC B
        MOV A,R3
        CJNE A,B,MFL27
        LJMP MFL100
MFL27:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator E
        INC B
        MOV A,R3
        CJNE A,B,MFL28
        LJMP MFL100
MFL28:  INC R0
        INC R0
        INC R1
        INC R1
        INC R6
        INC R6
        LCALL FUNCG             ;function generator F
MFL100: MOV TH0,R4
        MOV TL0,R5
        MOV TCON,#55h
MFL101: JNB PSW.1,MFL101        ;generates the additional time
        MOV TCON,#45h           ;delay
        CLR PSW.1
        JNB SCON.0,MFL102       ;checks if a "T" is pressed
        MOV A,SBUF
        CJNE A,#'T',MFL103
        CLR SCON.0
        SJMP MFL120
MFL103: CLR SCON.0
MFL102: MOV DPTR,#0C000h        ;updates the buffers of all
        MOVX A,@DPTR            ;DAC-s
        LJMP MFL13
MFL120: MOV DPL,#00h            ;clears all DAC-s configured
        MOV B,#00h              ;as function generators
MFL121: MOV A,#0E0h
        ADD A,B
        ADD A,B
        MOV DPH,A
        CLR A
        MOVX @DPTR,A
        INC B
        MOV A,R3
        CJNE A,B,MFL121
        MOV DPTR,#0C000h
        MOVX A,@DPTR
        LCALL TMESS
        RET
        NOP
        NOP
FUNCG:  MOV DPL,@R0             ;extracts the current value
        INC R0                  ;of the data pointer
        MOV DPH,@R0
        MOVX A,@DPTR
        MOV DPL,#00h
        MOV DPH,R6
        MOVX @DPTR,A            ;loads the current DAC with
        MOV DPH,@R0             ;the value
        DEC R0
        MOV DPL,@R0
        INC DPTR
        MOV A,@R1
        CJNE A,DPL,NOREL        ;compares if the data pointer
        INC R1                  ;for the current DAC has
        MOV A,@R1               ;reached its end value
        CJNE A,DPH,NOREL1
        DEC R1
        MOV A,B
        JNZ REL
        MOV @R0,#00h            ;reloads the current
        INC R0                  ;value of the data pointer
        MOV @R0,#00h            ;for DAC0 with initial
        DEC R0                  ;value 0000hex
        RET
REL:    DEC R1                  ;reloads the current
        DEC R1                  ;value for the data pointer
        MOV A,@R1               ;with the end value for
        MOV @R0,A               ;the previous DAC
        INC R0
        INC R1
        MOV A,@R1
        MOV @R0,A
        DEC R0
        INC R1
        RET
NOREL1: DEC R1
NOREL:  MOV @R0,DPL             ;loads the incremented
        INC R0                  ;value of the data pointer
        MOV @R0,DPH             ;as current value
        DEC R0
        RET


        org 6D80h
SFLKUP: db 'Please send the file!'
        db CR,LF,EOT


        org 6DA0h
MFLKUP: db 'Please send the file for function generator No '
        db 04h

        org 6E00h
EMLKUP: db 'ERROR! INVALID PARAMETERS'
        db CR,LF
        db 'PLEASE REPEAT INPUTS!'
        db CR,LF,EOT

        org 6E40h
TMLKUP: db CR,LF
        db 'The function was terminated!'
        db CR,LF
        db 'Part or all data is lost!'
        db CR,LF,EOT

        org 6F00h
IMLKUP: db '80C51-based DATA ACQUISITION SYSTEM EV'
        db CR,LF
        db 'SM<ENTER> - Single Measurement'
        db CR,LF
        db 'SSM<ENTER> - Single Synchronized Measurement'
        db CR,LF
        db 'MM<ENTER> - Multiple Measurement#16k'
        db CR,LF
        db 'MSM<ENTER> - Multiple Synchronized Measurement'
        db CR,LF
        db 'MM+<NNNN><ENTER> - Multiple Measurement with'
        db CR,LF
        db '                   time between points increased by NNNN'
        db CR,LF
        db 'MSM+<NNNN><ENTER> - Multiple Synchronized Measurement'
        db CR,LF
        db '                    with time between points '
        db 'incremented by NNNN'
        db CR,LF
        db 'DAC<N> <LL><ENTER> - Loading DAC N with the number LL'
        db CR,LF
        db 'SFG<N> <LLLL> - Configuring DAC N to work as '
        db 'function generator,'
        db CR,LF
        db '                loaded with a *.TXT file and '
        db 'additional time LLLL,'
        db CR,LF
        db '                inserted between the update points'
        db CR,LF
        db 'MFG<N> <LLLL> - Configuring all DAC-s till DAC N '
        db 'to work as function'
        db CR,LF
        db '                generators, loaded with *.TXT files '
        db 'and additional'
        db CR,LF
        db '                time LLLL, inserted between '
        db 'the update points'
        db CR,LF
        db CR,LF
        db 'By pressing "T" the current selected function '
        db 'is terminated!'
        db CR,LF,EOT

        END


